# mypy-boto3-xray

[![PyPI - mypy-boto3-xray](https://img.shields.io/pypi/v/mypy-boto3-xray.svg?color=blue)](https://pypi.org/project/mypy-boto3-xray)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-xray.svg?color=blue)](https://pypi.org/project/mypy-boto3-xray)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-xray](#mypy-boto3-xray)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.XRay 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/xray.html#XRay) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-xray](#mypy-boto3-xray)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `XRay` service.

```bash
python -m pip install boto3-stubs[xray]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_xray` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_xray import XRayClient

# Now mypy can check if your code is valid.
client: XRayClient = boto3.client("xray")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: XRayClient = session.client("xray")



# Annotated paginators are included as well

import mypy_boto3_xray.paginator as xray_paginators

batch_get_traces_paginator: xray_paginators.BatchGetTracesPaginator = client.get_paginator("batch_get_traces")
get_groups_paginator: xray_paginators.GetGroupsPaginator = client.get_paginator("get_groups")
get_sampling_rules_paginator: xray_paginators.GetSamplingRulesPaginator = client.get_paginator("get_sampling_rules")
get_sampling_statistic_summaries_paginator: xray_paginators.GetSamplingStatisticSummariesPaginator = client.get_paginator("get_sampling_statistic_summaries")
get_service_graph_paginator: xray_paginators.GetServiceGraphPaginator = client.get_paginator("get_service_graph")
get_time_series_service_statistics_paginator: xray_paginators.GetTimeSeriesServiceStatisticsPaginator = client.get_paginator("get_time_series_service_statistics")
get_trace_graph_paginator: xray_paginators.GetTraceGraphPaginator = client.get_paginator("get_trace_graph")
get_trace_summaries_paginator: xray_paginators.GetTraceSummariesPaginator = client.get_paginator("get_trace_summaries")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_xray` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_xray as xray
from mypy_boto3_xray import XRayClient

# with these
from mypy_boto3 import xray
from mypy_boto3.xray import XRayClient
```